package io.dekorate.openshift.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.AzureDiskVolume;
import io.dekorate.kubernetes.config.PersistentVolumeClaimVolume;
import io.dekorate.kubernetes.config.Port;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import io.dekorate.kubernetes.config.Label;
import io.dekorate.kubernetes.config.Mount;
import java.util.ArrayList;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.kubernetes.config.Probe;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.kubernetes.config.Container;
import io.dekorate.kubernetes.config.ContainerBuilder;
import java.lang.Deprecated;
import io.dekorate.kubernetes.annotation.ServiceType;
import io.dekorate.kubernetes.config.ContainerFluent;
import java.util.Iterator;
import java.lang.Boolean;
import io.dekorate.kubernetes.config.AwsElasticBlockStoreVolume;
import io.dekorate.kubernetes.config.ConfigMapVolume;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.SecretVolume;
import io.dekorate.kubernetes.config.BaseConfigFluent;
import io.dekorate.kubernetes.config.Annotation;
import io.dekorate.kubernetes.config.AzureFileVolume;
import io.dekorate.project.Project;
import io.dekorate.kubernetes.annotation.ImagePullPolicy;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;
import io.dekorate.kubernetes.config.GitRepoVolume;

public interface OpenshiftConfigFluent<A extends OpenshiftConfigFluent<A>> extends BaseConfigFluent<A>{


    public A withInitContainers(io.dekorate.kubernetes.config.Container... initContainers);
    
/**
 * This method has been deprecated, please use method buildInitContainers instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Container[] getInitContainers();
    public io.dekorate.kubernetes.config.Container[] buildInitContainers();
    public io.dekorate.kubernetes.config.Container buildInitContainer(int index);
    public io.dekorate.kubernetes.config.Container buildFirstInitContainer();
    public io.dekorate.kubernetes.config.Container buildLastInitContainer();
    public io.dekorate.kubernetes.config.Container buildMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public A addToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A setToInitContainers(int index,io.dekorate.kubernetes.config.Container item);
    public A addToInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A addAllToConfigInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeFromInitContainers(io.dekorate.kubernetes.config.Container... items);
    public A removeAllFromConfigInitContainers(Collection<io.dekorate.kubernetes.config.Container> items);
    public A removeMatchingFromConfigInitContainers(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public Boolean hasInitContainers();
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> addNewConfigInitContainer();
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> addNewInitContainerLike(io.dekorate.kubernetes.config.Container item);
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> setNewInitContainerLike(int index,io.dekorate.kubernetes.config.Container item);
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> editInitContainer(int index);
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> editFirstInitContainer();
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> editLastInitContainer();
    public OpenshiftConfigFluent.ConfigInitContainersNested<A> editMatchingInitContainer(io.dekorate.deps.kubernetes.api.builder.Predicate<ContainerBuilder> predicate);
    public int getReplicas();
    public A withReplicas(int replicas);
    public Boolean hasReplicas();
    public boolean isHeadless();
    public A withHeadless(boolean headless);
    public Boolean hasHeadless();

    public interface ConfigInitContainersNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,ContainerFluent<OpenshiftConfigFluent.ConfigInitContainersNested<N>>{

        
    public N and();    public N endConfigInitContainer();
}


}
